您的位置:首页 > 其它

HDU-3709 Balanced Number (数位DP)

2016-05-14 23:27 465 查看


Balanced Number

http://acm.hdu.edu.cn/showproblem.php?pid=3709

Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65535/65535 K (Java/Others)



Problem Description

A balanced number is a non-negative integer that can be balanced if a pivot is placed at some digit. More specifically, imagine each digit as a box with weight indicated by the digit. When a pivot is placed at some digit of the number, the distance from a digit
to the pivot is the offset between it and the pivot. Then the torques of left part and right part can be calculated. It is balanced if they are the same. A balanced number must be balanced with the pivot at some of its digits. For example, 4139 is a balanced
number with pivot fixed at 3. The torqueses are 4*2 + 1*1 = 9 and 9*1 = 9, for left part and right part, respectively. It's your job

to calculate the number of balanced numbers in a given range [x, y].

Input

The input contains multiple test cases. The first line is the total number of cases T (0 < T ≤ 30). For each case, there are two integers separated by a space in a line, x and y. (0 ≤ x ≤ y ≤ 1018).

Output

For each case, print the number of balanced numbers in the range [x, y] in a line.

Sample Input

2
0 9
7604 24324


Sample Output

10
897


题目大意:统计区间[l,r]中平衡数的个数?如果一个数以某一点为支点的力矩为0,则该数为平衡数。

又是一个状态很难想的数位DP

对于一个非0数x,最多只存在一个支点pivot使力矩为0

所以支点不同时的统计个数不重复(不包括0),可以直接相加

所以可以设dp[i][j][k]表示长度为i时,支点为j,且高位的数的力矩为k时,满足题意的数的个数

#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

const int MOD=2520;

int n,len,bit[25];
int ha[MOD];
long long l,r;
long long dp[25][25][1805];//dp[i][j][k]表示长度为i时,支点为j,且高位的数的力矩为k时,满足题意的数的个数

long long dfs(int pos,int pivot,int sum,bool limit) {//pos表示当前考虑的位,pivot为支点的位置,sum表示当前力矩和,limit表示当前位的数字上限是否有限制
if(pos<=0) {
return sum==0?1:0;
}
if(sum<0) {//如果当前力矩和已经小于0,则减去,因为力矩是非增的
return 0;
}
if(!limit&&dp[pos][pivot][sum]!=-1) {
return dp[pos][pivot][sum];
}

int mx=limit?bit[pos]:9;
long long res=0;
for(int i=0;i<=mx;++i) {
res+=dfs(pos-1,pivot,sum+(pos-pivot)*i,limit&&i==mx);
}
if(!limit&&dp[pos][pivot][sum]==-1) {
dp[pos][pivot][sum]=res;
}
return res;
}

long long getCnt(long long x) {//返回[0,x]中满足题意的数的答案
if(x==-1) {
return 0;
}
len=0;
while(x>0) {
bit[++len]=x%10;
x/=10;
}
long long ans=0;
for(int i=len;i>=1;--i) {//枚举支点
ans+=dfs(len,i,0,true);
}
return ans-len+1;//0,00,...,000000等都算满足题意,但只能算作0,减去重复考虑的
}

int main() {
int T;
memset(dp,-1,sizeof(dp));
scanf("%d",&T);
while(T-->0) {
scanf("%lld%lld",&l,&r);
printf("%lld\n",getCnt(r)-getCnt(l-1));
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: